Bug 523760 - If /usr/bin/update-packages fails between rename and commit, 404 Package not found errors appear
Summary: If /usr/bin/update-packages fails between rename and commit, 404 Package not ...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Satellite 5
Classification: Red Hat
Component: Upgrades
Version: 530
Hardware: All
OS: Linux
low
high
Target Milestone: ---
Assignee: Jan Pazdziora
QA Contact: Brandon Perkins
URL:
Whiteboard:
Depends On:
Blocks: sat531-blockers 523386
TreeView+ depends on / blocked
 
Reported: 2009-09-16 15:16 UTC by Jan Pazdziora
Modified: 2010-01-30 03:45 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2009-10-06 14:36:20 UTC


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHBA-2009:1479 normal SHIPPED_LIVE Red Hat Network Satellite bug fix update 2009-10-06 14:35:58 UTC

Description Jan Pazdziora 2009-09-16 15:16:59 UTC
Description of problem:

If there is a database issue (UNDO_TBS full, DATA_TBS full, network down), file can get renamed but the new path is not stored in database.

Then, errors similar to

   RHN 28350 2009/09/10 14:04:22 +02:00: ('Package not found',
   '/var/satellite/redhat/NULL/dhclient/12:3.0.5-18.el5/i386/dhclient-3.0.5-18.e
l5.i386.rpm')

will appear in /var/log/httpd/error_log during yum operation.

Version-Release number of selected component (if applicable):

Satellite pre-5.3.0, upgraded to 5.3.0.

How reproducible:

It's hard to reproduce in deterministic fashion.

Steps to Reproduce:
1. Run the /usr/bin/updated-packages during Satellite upgrade to 5.3, and kill the database in the middle.
2. But: see Additional info for alternative test plan.
  
Actual results:

Then, yum will fail for one or more packages.

Expected results:

The /usr/bin/update-packages should be self-healing.

Additional info:

We've seen the same problem when after a complete upgrade to Satellite 5.3.0, the database was restored from backup and schema upgrade rerun. Running update-packages with --debug then produces Missing Path message for every package.

The script should realize that the file was already renamed.

Comment 1 Jan Pazdziora 2009-09-16 15:18:57 UTC
Taking for now.

Comment 2 Jan Pazdziora 2009-09-16 15:19:34 UTC
Fix to just use the file found on the final location committed to Spacewalk master: 82afbb68ef1af1f87ba2a9e9466f14e67fbb053b.

Comment 3 Jan Pazdziora 2009-09-16 15:22:43 UTC
Additional fix (to the previous fix) in Spacewalk master: c95a6b21b9d41d3dbfa80a52e956142120763026.

Comment 4 Jan Pazdziora 2009-09-17 12:42:43 UTC
We shall read from the new file, even if we did not rename; Spacewalk master: 9f9f5476724c48bb87d52e5d9bcefbbfd91a2c39.

Comment 5 Milan Zázrivec 2009-09-22 12:37:58 UTC
satellite.git, SATELLITE-5.3: 18585b473f0e69af1704d2557c1aa946ff4a30a1

Comment 8 Milan Zázrivec 2009-09-25 07:41:26 UTC
rhn-upgrade-5.3.0.24-1.el4sat & rhn-upgrade-5.3.0.23-1.el5sat

Comment 12 errata-xmlrpc 2009-10-06 14:36:20 UTC
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHBA-2009-1479.html


Note You need to log in before you can comment on or make changes to this bug.